Index: src/Actions/MoleculeAction/TranslateAction.cpp
===================================================================
--- src/Actions/MoleculeAction/TranslateAction.cpp	(revision 4f2895fe90439ea317f5f52995da2eaa9bd4aac7)
+++ src/Actions/MoleculeAction/TranslateAction.cpp	(revision 4f2895fe90439ea317f5f52995da2eaa9bd4aac7)
@@ -0,0 +1,103 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2014 Frederik Heber. All rights reserved.
+ * 
+ *
+ *   This file is part of MoleCuilder.
+ *
+ *    MoleCuilder is free software: you can redistribute it and/or modify
+ *    it under the terms of the GNU General Public License as published by
+ *    the Free Software Foundation, either version 2 of the License, or
+ *    (at your option) any later version.
+ *
+ *    MoleCuilder is distributed in the hope that it will be useful,
+ *    but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *    GNU General Public License for more details.
+ *
+ *    You should have received a copy of the GNU General Public License
+ *    along with MoleCuilder.  If not, see <http://www.gnu.org/licenses/>.
+ */
+
+/*
+ * TranslateAction.cpp
+ *
+ *  Created on: Dec 14, 2014
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "CodePatterns/Chronos.hpp"
+
+#include "Actions/MoleculeAction/TranslateAction.hpp"
+
+#include "Actions/SelectionAction/Atoms/PushAtomsAction.hpp"
+#include "Actions/SelectionAction/Atoms/PopAtomsAction.hpp"
+#include "Actions/SelectionAction/Atoms/AllAtomsAction.hpp"
+#include "Actions/AtomAction/TranslateAction.hpp"
+#include "Actions/ActionQueue.hpp"
+#include "Actions/ActionSequence.hpp"
+
+#include "Descriptors/AtomDescriptor.hpp"
+
+using namespace MoleCuilder;
+
+// and construct the stuff
+#include "TranslateAction.def"
+#include "MakroAction_impl_pre.hpp"
+/** =========== define the function ====================== */
+
+// static instances
+ActionSequence MoleculeTranslateAction::actions;
+bool MoleculeTranslateAction::isPrepared = false;
+
+void MoleculeTranslateAction::prepare(ActionRegistry &AR)
+{
+  // we simply have to select all the molecule's atoms and use the respective
+  // translate Action
+  actions.addAction(AR.getActionByName(std::string("push-atom-selection")));
+  actions.addAction(AR.getActionByName(std::string("select-molecules-atoms")));
+  actions.addAction(AR.getActionByName(std::string("translate-atoms")));
+  actions.addAction(AR.getActionByName(std::string("pop-atom-selection")));
+  isPrepared = true;
+}
+
+void MoleculeTranslateAction::unprepare(ActionRegistry &AR)
+{
+  // empty sequence
+  while (actions.removeLastAction() != NULL);
+  isPrepared = false;
+}
+
+ActionState::ptr MoleculeTranslateAction::performCall(){
+  ActionState::ptr state(MakroAction::performCall());
+
+  return state;
+}
+
+ActionState::ptr MoleculeTranslateAction::performUndo(ActionState::ptr _state) {
+  ActionState::ptr state(MakroAction::performUndo(_state));
+
+  return state;
+}
+
+ActionState::ptr MoleculeTranslateAction::performRedo(ActionState::ptr _state){
+  ActionState::ptr state(MakroAction::performRedo(_state));
+
+  return state;
+}
+
+bool MoleculeTranslateAction::canUndo(){
+  return true;
+}
+
+bool MoleculeTranslateAction::shouldUndo(){
+  return true;
+}
Index: src/Actions/MoleculeAction/TranslateAction.def
===================================================================
--- src/Actions/MoleculeAction/TranslateAction.def	(revision 4f2895fe90439ea317f5f52995da2eaa9bd4aac7)
+++ src/Actions/MoleculeAction/TranslateAction.def	(revision 4f2895fe90439ea317f5f52995da2eaa9bd4aac7)
@@ -0,0 +1,33 @@
+/*
+ * TranslateAction.def
+ *
+ *  Created on: Dec 14, 2014
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "unundef" if no parameters are required, use (NOPARAM_DEFAULT) for each (defined) default value
+#undef paramtypes
+#undef paramtokens
+#undef paramdescriptions
+#undef paramreferences
+#undef paramdefaults
+#undef paramvalids
+
+#undef statetypes
+#undef statereferences
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Molecule
+#define MENUNAME "molecule"
+#define MENUPOSITION 6
+#define ACTIONNAME Translate
+#define TOKEN "translate-molecules"
+
+
+// finally the information stored in the ActionTrait specialization
+#define DESCRIPTION "translate all selected molecules by given vector"
+#undef SHORTFORM
Index: src/Actions/MoleculeAction/TranslateAction.hpp
===================================================================
--- src/Actions/MoleculeAction/TranslateAction.hpp	(revision 4f2895fe90439ea317f5f52995da2eaa9bd4aac7)
+++ src/Actions/MoleculeAction/TranslateAction.hpp	(revision 4f2895fe90439ea317f5f52995da2eaa9bd4aac7)
@@ -0,0 +1,22 @@
+/*
+ * TranslateAction.hpp
+ *
+ *  Created on: Dec 14, 2013
+ *      Author: heber
+ */
+
+#ifndef MOLECULE_TRANSLATEACTION_HPP_
+#define MOLECULE_TRANSLATEACTION_HPP_
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+
+#include "Actions/MakroAction.hpp"
+
+#include "TranslateAction.def"
+#include "MakroAction_impl_header.hpp"
+
+#endif /* MOLECULE_TRANSLATEACTION_HPP_ */
